Function read_file_proc(pszNameFile As ZString Ptr, ByRef iSize As Long) As Byte Ptr

	If Len(*pszNameFile) = 0 Then Return 0

	Dim id As Long

	Dim As Byte Ptr pbData

	id = FreeFile

	Open *pszNameFile For Binary As #id

	If Err = 0 Then

		iSize = Lof(id)

		pbData = Allocate(iSize+1)

		Get #id , 1 , *pbData , iSize

		pbData[iSize] = 0

		Close #id

		Return pbData

	EndIf

End Function

Function write_file_proc(pszNameFile As ZString Ptr, pbData As Byte Ptr,  iSize As Long) As Long
	
	If Len(*pszNameFile) = 0 Then Return 0

	If FileExists(*pszNameFile) = -1 Then

		If Kill(*pszNameFile) <> 0 Then

			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"errorrewite"))

		EndIf

	EndIf

	Dim id As Long

	id = FreeFile

	Open *pszNameFile For Binary As #id

	If Err = 0 Then

		Put #id , 1 , *pbData , iSize

		Close #id

		Return 1

	EndIf

End Function

Function prepare_before_saving( ByRef iSizeReturn As Long , idTabs As Long ) As Byte Ptr
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return 0
	
	Dim As ZString Ptr pszData  = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "VALUE")
	
	Dim As ZString Ptr pszCurrentEnc = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING")
	
	Dim As Long iSize = Len(*pszData)
	
	Dim As Long iUnicode
	
	If iSize > 3 Then
	
		iUnicode = Cast(Long Ptr,pszData)[0]
	
	EndIf
	
	Select Case *pszCurrentEnc
	
		#Ifdef __FB_WIN32__
		
		Case "UTF-8" , "UTF-8 BOM"
		
		#Else
		
		Case "UTF-8" , "UTF-8 BOM" , "Default System" , ""
		
		#EndIf
			
			
			If *pszCurrentEnc = "UTF-8 BOM" Then
			
				If iUnicode <> 0 AndAlso (iUnicode And &hFFFFFF) = &hBFBBEF Then
			
					Dim As ZString Ptr pszTemp = Callocate (iSize+1)
			
					*pszTemp = *pszData
			
					iSizeReturn = Len(*pszTemp)
			
					Function =  Cast(Byte Ptr,pszTemp)
			
				Else
			
					Dim As ZString Ptr pszTemp = Callocate (iSize+4)
			
					*pszTemp = Chr(&hEF,&hBB,&hBF)
			
					*pszTemp = *pszTemp & *pszData
			
					iSizeReturn = Len(*pszTemp)
			
					Function =  Cast(Byte Ptr,pszTemp)
			
				EndIf
			
			Else
			
				If iUnicode <> 0 AndAlso (iUnicode And &hFFFFFF) = &hBFBBEF Then
			
					Dim As ZString Ptr pszTemp = Callocate (iSize+1)
			
					*pszTemp = Mid(*pszData,4,Len(*pszData)-3)
			
					iSizeReturn = Len(*pszTemp)
			
					Function =  Cast(Byte Ptr,pszTemp)
			
				Else
			
					Dim As ZString Ptr pszTemp = Callocate (iSize+4)
			
					*pszTemp = *pszData
			
					iSizeReturn = Len(*pszTemp)
			
					Function =  Cast(Byte Ptr,pszTemp)
			
				EndIf
			
			EndIf
		
		Case Else	
			
			Dim As Byte Ptr pszToCode		
			
			Dim iSizeRetIconv As Integer		
			
			If iUnicode <> 0 AndAlso (iUnicode And &hFFFFFF) = &hBFBBEF Then
		
				Dim As ZString Ptr pszReturnData = Callocate (iSize+1)
		
				*pszReturnData = Mid(*pszData,4,Len(*pszData)-3)
		
				iSize = Len(*pszReturnData)
				
				pszToCode = encode_buffer_proc(pszCurrentEnc , "UTF-8" , pszReturnData , iSize ,iSizeRetIconv)
				
				DeAllocate (pszReturnData)
					
			Else
				
				pszToCode = encode_buffer_proc(pszCurrentEnc , "UTF-8" , pszData , iSize ,iSizeRetIconv) 
				
			EndIf	
					
			If iSizeRetIconv > 3 Then

				iUnicode = Cast(Long Ptr,pszToCode)[0]
				
			Else
				
				iUnicode = 0

			EndIf							
			
			iSizeReturn = iSizeRetIconv	
		
			Select Case *pszCurrentEnc
		
				Case	"UTF-32LE" , "UCS-4LE"
						
					If iUnicode <> 0 AndAlso iUnicode = &hFEFF Then
					
						Return pszToCode
					
					Else
					
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+5)
						
						*Cast(Long Ptr,pbReturnData) = &hFEFF
						
						memcpy((pbReturnData+4), pszToCode , iSizeRetIconv)
						
						DeAllocate ( pszToCode )
						
						iSizeReturn+=4
						
						Return pbReturnData
					
					EndIf
				
				Case 	"UTF-32BE","UCS-4BE"
				
					If iUnicode <> 0 AndAlso iUnicode = &hFFFE0000 Then
					
						Return pszToCode
					
					Else
					
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+5)
						
						*Cast(Long Ptr,pbReturnData) = &hFFFE0000
						
						memcpy((pbReturnData+4), pszToCode , iSizeRetIconv)
						
						DeAllocate ( pszToCode )		
						
						iSizeReturn+=4		
						
						Return pbReturnData	
					
					EndIf
				
				Case  "UTF-32","UCS-4","UCS-4-INTERNAL"
				
					If iUnicode <> 0 AndAlso (iUnicode = &hFFFE0000 OrElse iUnicode = &hFEFF)  Then
					
						Return pszToCode
					
					Else
					
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+5)
						
						*Cast(Long Ptr,pbReturnData) = &hFEFF
						
						memcpy((pbReturnData+4), pszToCode , iSizeRetIconv)
						
						DeAllocate ( pszToCode )		
						
						iSizeReturn+=4		
						
						Return pbReturnData	
					
					EndIf
				
				Case "UTF-16LE" , "UCS-2LE"
				
					If iUnicode <> 0 AndAlso ((iUnicode And &hFFFF) = &hFEFF)  Then
					
						Return pszToCode
					
					Else
					
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+3)
						
						*Cast(Short Ptr,pbReturnData) = &hFEFF
						
						memcpy((pbReturnData+2), pszToCode , iSizeRetIconv)
						
						DeAllocate ( pszToCode )	
						
						iSizeReturn+=2		
						
						Return pbReturnData			
					
					EndIf
				
				Case "UTF-16BE" , "UCS-2BE"
				
					If iUnicode <> 0 AndAlso ((iUnicode And &hFFFF) = &hFFFE)  Then
					
						Return pszToCode
					
					Else
					
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+3)
						
						*Cast(Short Ptr,pbReturnData) = &hFFFE
						
						memcpy((pbReturnData+2), pszToCode , iSizeRetIconv)
						
						DeAllocate ( pszToCode )	
						
						iSizeReturn+=2		
						
						Return pbReturnData			
					
					EndIf
				
				Case "UTF-16" , "UCS-2" , "UCS-2-INTERNAL"
				
					If iUnicode <> 0 AndAlso (((iUnicode And &hFFFF) = &hFFFE) OrElse ((iUnicode And &hFFFF) = &hFEFF)) Then
					
						Return pszToCode
					
					Else
					
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+3)
						
						*Cast(Short Ptr,pbReturnData) = &hFEFF
						
						memcpy((pbReturnData+2), pszToCode , iSizeRetIconv)
						
						DeAllocate ( pszToCode )	
						
						iSizeReturn+=2		
						
						Return pbReturnData			
					
					EndIf
				
				Case Else
					
					Return pszToCode
		
			End Select
		
	End Select

End Function

Function save_as_proc(idTabs As Long ) As Long
	
	Dim As Long iSizeReturn
	
	Dim As ZString Ptr pszPath
	
	Static As String szPath
	
	Dim As Byte Ptr pbData = prepare_before_saving(iSizeReturn , idTabs )
	
	If pbData <> 0 Then
		
		pszPath = save_dialog_proc()
		
		If *pszPath<>"" Then
			
			If write_file_proc(pszPath,pbData,iSizeReturn) = 0 Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorwritefile"))
				
			Else
				
				#Ifdef __FB_WIN32__
				
					Dim As Long iPosSpl = InStrRev (*pszPath,"\")
				
				#Else
				
					Dim As Long iPosSpl = InStrRev (*pszPath,"/")
				
				#EndIf
				
				Dim As ZString*1000 sztPath, sztName , szToCode
			
				sztPath = Mid(*pszPath,1,iPosSpl)
			
				sztName = Mid(*pszPath,iPosSpl+1,Len(*pszPath)-iPosSpl)				
				
				IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILEPATH", sztPath)
			
				IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME", sztName)
				
				IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "NO")
				
				Dim As ZString*1000 szTempBufPath = sztPath & sztName
				
				Dim As ZString*2 szEncZero = ""
				
				Dim As Integer iSizeRet
				
				Dim As ZString Ptr pszEncPath = Cast(ZString Ptr,encode_buffer_proc("UTF-8",StrPtr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
				
				IupConfigRecentUpdate(TGlobalVariables->hConfig, pszEncPath )
				
				If pszEncPath Then DeAllocate (pszEncPath)
				
				#Ifdef __FB_WIN32__
					
					iSizeRet = 0
					
					Dim As ZString Ptr pszCodedNameTab = Cast(ZString Ptr,encode_buffer_proc("UTF-8",StrPtr(szEncZero), Cast(Byte Ptr,@sztName), Len(sztName) , iSizeRet))
					
					If pszCodedNameTab Then
						
						IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAMETAB", pszCodedNameTab)
						
						DeAllocate (pszCodedNameTab)
						
					EndIf
				
				#Else
				
					IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAMETAB", sztName )
				
				#EndIf				
				
				IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", idTabs ,IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAMETAB"))
			   
			   szPath = "IUP_FB_Editor - " & sztPath & sztName
			   
			   szPath = encode_path(szPath , 1)
				
				IupSetAttribute(TGlobalVariables->dlg, "TITLE", szPath)
			   
				IupRefresh(TGlobalVariables->dlg)
				
				IupSetFocus(TGlobalVariables->tTabsOptions(idtabs).multitext)
				
				Function = 1			
			
			EndIf		
					
		EndIf
		
		DeAllocate(pbData)
		
	EndIf		
	
End Function

Function save_proc(idTabs As Long ) As Long
				
	Dim As ZString Ptr pszName = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME")
	
	Dim As ZString Ptr pszPath = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILEPATH")
	
	Static As String szPath
	
	If len(*pszName) = 0 Then
		
		save_as_proc(idTabs)
		
	Else
		
		Dim As Long iSizeReturn
	
		Dim As Byte Ptr pbData = prepare_before_saving(iSizeReturn , idTabs )
		
		If pbData <> 0 Then
			
			Dim As ZString*1000 sztPath = *pszPath & *pszName
		
			If write_file_proc(sztPath ,pbData,iSizeReturn) = 0 Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
				 *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorwritefile"))
				
				DeAllocate(pbData)
				
			Else
				
				IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "NO")
				
				IupSetFocus(TGlobalVariables->tTabsOptions(idtabs).multitext)
				
				szPath = "IUP_FB_Editor - " & *pszPath & *pszName
				
				szPath = encode_path(szPath , 1)
				
				IupSetAttribute(TGlobalVariables->dlg, "TITLE", szPath)
				
				DeAllocate(pbData)
				
				Return 1
			
			EndIf
		
		EndIf
		
	EndIf
	
End Function

Sub save_all_proc() 
	
	Dim As Long  ic = IupGetChildCount(TGlobalVariables->tabs)
	
	If ic < 2 Then Exit Sub
	
	For i As Long = 1 To ic-1
		
		save_proc(i)
		
	Next
	
End Sub

Sub open_file_proc (pszPath As ZString Ptr)
	
	If pszPath = 0 Then Exit Sub
	
	#Ifdef __FB_WIN32__
	#Else
	
	Dim As String*1000 szPath2

	For i As Long = 0 To Len(*pszPath)-1
		
		If (*pszPath)[i] = &h25 Then
			
			Var szSimvol = "&h" & chr((*pszPath)[i+1], (*pszPath)[i+2])
			
			Var iSimvol = Val(szSimvol)
			
			szPath2 &= Chr(iSimvol)
			
			i+=2
		Else
			
			szPath2 &= Chr((*pszPath)[i])
			
		EndIf
		
	Next
	
	*pszPath = szPath2
	
	#EndIf	
	
	If Right(*pszPath,1) = "|" Then

		Dim As Long iPosSpl = InStr (*pszPath,"|")
		
		Dim As Integer  ic = IupGetChildCount(TGlobalVariables->tabs)
		
		Dim As ZString*1000 sztPath , sztName
		
		#Ifdef __FB_WIN32__
		
			sztPath = Mid(*pszPath,1,iPosSpl-1) & "\"
		
		#Else
		
			sztPath = Mid(*pszPath,1,iPosSpl-1) & "/"
		
		#EndIf
		
		While 1
		
			Dim As Long iPosEndSpl = InStr (iPosSpl+1,*pszPath,"|")
			
			sztName = Mid(*pszPath,iPosSpl+1,iPosEndSpl-(iPosSpl+1))
			
			#Ifdef __FB_WIN32__
			
				Dim As Integer iSizeTempRet
				
				Dim As ZString*2 szZero = ""
				
				Dim As ZString ptr pszToCode
				
				pszToCode = Cast(ZString Ptr ,encode_buffer_proc("UTF-8" , szZero , Cast(Byte Ptr,@sztName) , Len(sztName) , iSizeTempRet))
			
			#EndIf
			
			iPosSpl = iPosEndSpl
			
			Dim iSizeFile As Long
			
			Dim As Byte Ptr pbData = read_file_proc(sztPath & sztName , iSizeFile)
			
			If pbData <> 0 Then
			
				Dim As Long iUnicode = Cast(Long Ptr,pbData)[0]
				
				Dim As ZString*21 szEnc
				
				If iUnicode = &hFEFF Then
				
					szEnc = "UTF-32LE"
				
				ElseIf iUnicode = &hFFFE0000 Then
				
					szEnc = "UTF-32BE"
				
				ElseIf (iUnicode And &hFFFF) = &hFEFF Then
				
					szEnc = "UTF-16LE"
				
				ElseIf (iUnicode And &hFFFF) = &hFFFE Then
				
					szEnc = "UTF-16BE"
				
				ElseIf (iUnicode And &hFFFFFF) = &hBFBBEF Then
				
					szEnc = "UTF-8 BOM"
				
				Else
				
					szEnc = TGlobalVariables->szDefaultSystemEncoding
				
				EndIf
				
				Dim As Ihandle Ptr mt = IupScintilla()
				
				IupSetStrAttribute(mt, "CURRENTENCODING", szEnc)
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(mt, "CURRENTENCODING"))
				
				IupAppend(TGlobalVariables->tabs,mt)
				
				IupMap(mt)
				
				set_attribute_multitext_proc(mt)
	
				Dim As Integer iSizeReturn
				
				Dim As Byte Ptr pbFileToCode
				
				If szEnc = "UTF-8 BOM" Then
				   
				   pbFileToCode = encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , mt)
				   
				Else
				   
				   pbFileToCode = encode_buffer_proc("UTF-8" , szEnc , pbData , iSizeFile , iSizeReturn , mt)
				   
				EndIf			
				
				IupSetStrAttribute(mt, "FILEPATH", sztPath)
				
				IupSetStrAttribute(mt, "FILENAME", sztName)
				
				Dim As ZString*1000 szTempBufPath = sztPath & sztName
				
				Dim As ZString*2 szEncZero = ""
				
				Dim As Integer iSizeRet
				
				Dim As ZString Ptr pszEncPath = Cast(ZString Ptr,encode_buffer_proc("UTF-8",StrPtr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
				
				IupConfigRecentUpdate(TGlobalVariables->hConfig, pszEncPath )
				
				If pszEncPath Then DeAllocate (pszEncPath)
				
				#Ifdef __FB_WIN32__
				
					If pszToCode Then
						
						IupSetStrAttribute(mt, "FILENAMETAB", pszToCode)
						
						DeAllocate (pszToCode)
						
					EndIf					
				
				#Else
				
					IupSetStrAttribute(mt, "FILENAMETAB", sztName)
				
				#EndIf
				
				IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,IupGetAttribute(mt, "FILENAMETAB"))
				
				IupRefresh(TGlobalVariables->dlg)
				
				IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
				
				IupSetStrAttribute(mt, "VALUE", pbFileToCode)
				
				If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
				
					IupScintillaSendMessage( mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
				
				Else
				
					IupScintillaSendMessage( mt , SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
				
				EndIf
				
				TGlobalVariables->tTabsOptions(ic).multitext = mt
				
				IupSetAttribute(mt, "ISCHANGES", "NO")
				
				DeAllocate (pbFileToCode)
				
				DeAllocate (pbData)
				
				ic+=1
			
			EndIf	
			
			If iPosEndSpl = Len(*pszPath) Then Exit While
		
		Wend	
	
	Else
	
		#Ifdef __FB_WIN32__
		
			Dim As Long iPosSpl = InStrRev (*pszPath,"\")
		
		#Else
		
			Dim As Long iPosSpl = InStrRev (*pszPath,"/")
		
		#EndIf
		
		Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
		
		Dim iSizeFile As Long
		
		Dim As Byte Ptr pbData = read_file_proc(pszPath,iSizeFile)
		
		If pbData <> 0 Then
		
			Dim As Long iUnicode = Cast(Long Ptr,pbData)[0]
			
			Dim As ZString*21 szEnc
			
			If iUnicode = &hFEFF Then
			
				szEnc = "UTF-32LE"
			
			ElseIf iUnicode = &hFFFE0000 Then
			
				szEnc = "UTF-32BE"
			
			ElseIf (iUnicode And &hFFFF) = &hFEFF Then
			
				szEnc = "UTF-16LE"
			
			ElseIf (iUnicode And &hFFFF) = &hFFFE Then
			
				szEnc = "UTF-16BE"
			
			ElseIf (iUnicode And &hFFFFFF) = &hBFBBEF Then
			
				szEnc = "UTF-8 BOM"
			
			Else
			
				szEnc = TGlobalVariables->szDefaultSystemEncoding
			
			EndIf
			
			Dim As Ihandle Ptr mt = IupScintilla()
			
			IupSetStrAttribute(mt, "CURRENTENCODING", szEnc)
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(mt, "CURRENTENCODING"))
			
			IupAppend(TGlobalVariables->tabs,mt)
			
			IupMap(mt)
			
			set_attribute_multitext_proc(mt)
			
			Dim As ZString*1000 sztPath, sztName
			
			If iPosSpl = 0 Then
				
				sztPath = ""
				
			Else
				
				sztPath = Mid(*pszPath,1,iPosSpl)
				
			EndIf
			
			sztName = Mid(*pszPath,iPosSpl+1,Len(*pszPath)-iPosSpl)
			
			#Ifdef __FB_WIN32__				
				
				Dim As Integer iSizeTempRet
				
				Dim As ZString*2 szZero = ""
				
				Dim As ZString ptr pszToCode
				
				pszToCode = Cast(ZString Ptr ,encode_buffer_proc("UTF-8" , szZero , Cast(Byte Ptr,@sztName) , Len(sztName) , iSizeTempRet))		
				
				If pszToCode Then
					
					IupSetStrAttribute(mt, "FILENAMETAB", pszToCode)
					
					DeAllocate (pszToCode)
					
				EndIf					
			
			#Else
			
				IupSetStrAttribute(mt, "FILENAMETAB", sztName )
			
			#EndIf
			
			Dim As Integer iSizeReturn
			
			Dim As Byte Ptr pbFileToCode
			
			If szEnc = "UTF-8 BOM" Then
			   
			   pbFileToCode = encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , mt)
			   
			Else
			   
			   pbFileToCode = encode_buffer_proc("UTF-8" , szEnc , pbData , iSizeFile , iSizeReturn , mt)		
			   
			EndIf   
							
			
			IupSetStrAttribute(mt, "FILEPATH", sztPath)
			
			IupSetStrAttribute(mt, "FILENAME", sztName)
			
			Dim As ZString*1000 szTempBufPath = sztPath & sztName
			
			Dim As ZString*2 szEncZero = ""
			
			Dim As Integer iSizeRet
			
			Dim As ZString Ptr pszEncPath = Cast(ZString Ptr,encode_buffer_proc("UTF-8",StrPtr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
			
			IupConfigRecentUpdate(TGlobalVariables->hConfig, pszEncPath )
			
			If pszEncPath Then DeAllocate (pszEncPath)
			
			TGlobalVariables->tTabsOptions(ic).multitext = mt
			
			IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,IupGetAttribute(mt, "FILENAMETAB"))
			
			IupRefresh(TGlobalVariables->dlg)
			
			IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
			
			IupSetStrAttribute(mt, "VALUE", pbFileToCode)
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
				
				IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
				
			Else
				
				IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
				
			EndIf			
			
			IupSetAttribute(mt, "ISCHANGES", "NO")
			
			DeAllocate (pbFileToCode)
			
			DeAllocate (pbData)
			
			IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(ic))
		
		EndIf
	
	EndIf

End Sub


Sub re_open_file_proc (pszEnc As ZString Ptr)

	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As ZString*1000 szPath = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILEPATH") & _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME")
	
	If szPath = "" Then Exit Sub
	
	Dim As ZString Ptr pszPath  = StrPtr( szPath )
	
	Dim iSizeFile As Long
	
	Dim As Byte Ptr pbData = read_file_proc(pszPath , iSizeFile)
	
	If pbData <> 0 Then
		
		If *pszEnc = "Default System" Then
		
			*pszEnc = TGlobalVariables->szDefaultSystemEncoding
		
		EndIf
				
		Dim As Integer iSizeReturn
		
		Dim As Byte Ptr pbToCode
		
		If *pszEnc = "UTF-8 BOM" Then
		   
		   pbToCode = encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn)	
		   
		Else
		   
		   pbToCode = encode_buffer_proc("UTF-8" , pszEnc , pbData , iSizeFile , iSizeReturn)
		   
		EndIf	
			
		   
		If pbToCode Then
			
			IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "VALUE", pbToCode)
			
			IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "NO")	
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
				
				IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
				
			Else
				
				IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
				
			EndIf
			
		EndIf	
		
		DeAllocate (pbToCode)
	
		DeAllocate (pbData)
		
	EndIf
	
	IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING", pszEnc)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING"))

End Sub

Sub new_file_proc() 
	
	Var mt = IupScintilla()
	
	IupSetStrAttribute(mt, "CURRENTENCODING", TGlobalVariables->szDefaultSystemEncoding)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , TGlobalVariables->szDefaultSystemEncoding)
	
	Var ic = IupGetChildCount(TGlobalVariables->tabs)
	
	IupAppend(TGlobalVariables->tabs,mt)
	
	IupMap(mt)
	
	set_attribute_multitext_proc(mt)
	
	IupSetAttribute(mt, "ISCHANGES", "NO")
	
	TGlobalVariables->tTabsOptions(ic).multitext = mt
	
	IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,"New")
	
	IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(ic))
	
	IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - New")
	
	If IupScintillaSendMessage(mt, SCI_GETEOLMODE, 0  ,  0 ) = SC_EOL_CRLF Then

	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
	   
	Else

	   IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
	   
	EndIf	
	
	IupRefresh(TGlobalVariables->dlg)
	
	IupSetFocus(mt)	
	
End Sub

Sub open_include_files()
            
   Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
   
   Dim As Integer iPosCaret = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
   
   Dim As Integer iLine , iColumn
   
   IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPosCaret, cast(any ptr, @iLine), cast(any ptr, @iColumn))
   
   Dim As String sText = *IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", iLine )
   
   sText = LTrim(sText , Any " " & Chr(9) )
   
   If Left(LCase(sText), 8 ) = "#include" Then
      
      Dim As Long iFindBeg , iFindEnd
      
      iFindBeg = InStr(sText,Chr(34))
      
      If iFindBeg Then
         
         iFindEnd = InStr(iFindBeg+1,sText,Chr(34))
         
         If iFindEnd Then
            
            sText = Mid(sText,iFindBeg+1,(iFindEnd-iFindBeg)-1)
            
         Else
            
            sText = Mid(sText,iFindBeg+1)
            
         EndIf
         
         #Ifdef __FB_WIN32__
         
         sText = replace_string_proc(sText , "/","\",,1)
         
         #EndIf
         
         Dim As String sPathCurent = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext,"FILEPATH")
         
         Dim As Integer iCountTabs = IupGetInt(TGlobalVariables->tabs, "COUNT")
         
         If Len(sPathCurent) Then
            
            sPathCurent = encode_path(sPathCurent , 0)
            
            sPathCurent = sPathCurent & sText                  
            
            If FileExists(sPathCurent) = -1 Then                                               
               
               open_file_proc(sPathCurent)
               
               IupSetFocus(TGlobalVariables->tTabsOptions(iCountTabs).multitext)
               
               Exit Sub
               
            EndIf
            
         EndIf 
         
         sPathCurent = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude")
         
         If Len(sPathCurent) Then
            
            If Left(sPathCurent , 2) = "$A" Then
            
               sPathCurent = ExePath() & Mid( sPathCurent , 3)
            
            EndIf  
            
            sPathCurent = encode_path(sPathCurent , 0)
            
            If Right(sPathCurent,1) <> "\" AndAlso Right(sPathCurent,1) <> "/" Then
               
               #Ifdef __FB_WIN32__
               
               sPathCurent = sPathCurent & "\"
               
               #else
               
               sPathCurent = sPathCurent & "/"
               
               #EndIf
               
            EndIf
            
            sPathCurent = sPathCurent & sText                  
            
            If FileExists(sPathCurent) = -1 Then                                               
               
               open_file_proc(sPathCurent)
               
               IupSetFocus(TGlobalVariables->tTabsOptions(iCountTabs).multitext)
               
            EndIf                     
            
         EndIf
         
      EndIf
      
   EndIf
   
End Sub

