Type Tlistnode

	As ZString Ptr pszCommand

	As ZString Ptr pszName

	As Tlistnode ptr pNext

	As Tlistnode ptr pPrev

End Type

Type Tlist

	Declare Sub insert( iIndex As Integer , pszCommand As ZString Ptr , pszName As ZString Ptr )

	Declare function del( iIndex As Integer ) As Integer
	
	Declare Sub delAll()

	Declare function Move( iIndexFrom As Long  , iIndexIn As Long) As Integer
	
	Declare Function getNode(iIndex As Long) As Tlistnode Ptr

	Declare function count() As Long

	As Tlistnode ptr pFirst

End Type

function Tlist.count() As Long

	Dim As Tlistnode Ptr pTemp = pFirst

	Dim As Long iListIndex

	While pTemp

		iListIndex+=1

		pTemp = pTemp->pNext

	Wend

	Return iListIndex

End Function

Function Tlist.getNode(iIndex As Long) As Tlistnode Ptr
	
	Dim As Long iCount = count()
	
	If iIndex >= iCount OrElse iIndex < 0 OrElse pFirst = 0 Then
		
		Return Cast(Any Ptr, -1)
		
	EndIf	
	
	Dim As Tlistnode Ptr pTemp = pFirst

	Dim As Long iListIndex
	
	While pTemp
		
		If iIndex = iListIndex Then
			
			Return pTemp
			
		EndIf
		
		iListIndex+=1

		pTemp = pTemp->pNext

	Wend		
	
End Function

Sub Tlist.insert( iIndex As Integer , pszCommand As ZString Ptr , pszName As ZString Ptr )

	If pFirst = 0 Then

		pFirst = New Tlistnode

		pFirst->pszCommand = pszCommand

		pFirst->pszName = pszName

	Else

		Dim As Long iCount = count()

		Dim As Tlistnode Ptr pTemp = pFirst , pTempNew

		Dim As Long iListIndex

		If iIndex = 0 Then

			pTempNew = New Tlistnode

			pFirst->pPrev = pTempNew

			pTempNew->pNext = pFirst

			pFirst = pTempNew

			pTempNew->pszCommand = pszCommand

			pTempNew->pszName = pszName			

		Else

			If iIndex >= iCount Then

				pTempNew = New Tlistnode

				While pTemp

					If pTemp->pNext = 0 Then

						pTemp->pNext = pTempNew

						pTempNew->pPrev = pTemp

						pTempNew->pszCommand = pszCommand

						pTempNew->pszName = pszName

						Exit While

					EndIf
					
					pTemp = pTemp->pNext

				Wend

			Else

				While pTemp

					If iListIndex = iIndex Then

						pTempNew = New Tlistnode

						pTempNew->pNext = pTemp
						
						pTempNew->pPrev = pTemp->pPrev
						
						pTemp->pPrev->pNext = pTempNew
						
						pTemp->pPrev = pTempNew

						pTempNew->pszCommand = pszCommand

						pTempNew->pszName = pszName

						Exit While

					EndIf

					pTemp = pTemp->pNext

					iListIndex+=1

				Wend

			EndIf

		endif

	EndIf

End Sub

Sub Tlist.delAll()
	
	Dim As Tlistnode Ptr pTemp = pFirst , pTemp2
	
	While pTemp
		
		pTemp2 = pTemp
		
		pTemp = pTemp->pNext
		
		If (pTemp2->pszCommand) Then DeAllocate(pTemp2->pszCommand)
		
		If (pTemp2->pszName) Then DeAllocate(pTemp2->pszName)
		
		Delete pTemp2
		
	Wend
	
End Sub

function Tlist.del( iIndex As Integer ) As Integer

	If pFirst = 0 Then

		Return -1

	Else
		
		Dim As Long iCount = count()
		
		If iIndex >= iCount OrElse iIndex < 0 Then
			
			Return -1
			
		EndIf

		Dim As Tlistnode Ptr pTemp = pFirst , pTemp2

		Dim As Long iListIndex

		While pTemp

			If iListIndex = iIndex Then

				If pTemp = pFirst Then

					pFirst = pTemp->pNext

					If pFirst Then pFirst->pPrev = 0

				Else

					If pTemp->pNext = 0 Then

						pTemp->pPrev->pNext = 0

					Else

						pTemp->pPrev->pNext = pTemp->pNext

						pTemp->pNext->pPrev = pTemp->pPrev

					EndIf

				EndIf
				
				If (pTemp->pszCommand) Then DeAllocate ( pTemp->pszCommand )
				
				If (pTemp->pszName) Then DeAllocate ( pTemp->pszName )
				
				Delete pTemp

				Exit While

			EndIf

			pTemp = pTemp->pNext

			iListIndex+=1

		Wend

	EndIf

End Function

function Tlist.Move( iIndexFrom As Long  , iIndexIn As Long) As Integer

	If iIndexFrom = iIndexIn OrElse pFirst = 0 Then

		Return -1

	EndIf
	
	Dim As Long iCount = count()
	
	If iIndexFrom >= iCount OrElse iIndexFrom < 0 OrElse iIndexIn >= iCount OrElse iIndexIn < 0 Then
		
		Return -1
		
	EndIf

	Dim As Tlistnode Ptr pOut  , pIn , pTemp = pFirst , pTemp2

	Dim As Long iListIndex

	While pTemp

		If iListIndex = iIndexFrom Then

			pOut = pTemp

		ElseIf iListIndex = iIndexIn Then

			pIn = pTemp

		EndIf

		pTemp = pTemp->pNext

		iListIndex+=1

		If pOut andalso pIn Then Exit While

	Wend

	If pOut->pNext = 0  AndAlso pIn->pPrev = 0 Then

		pOut->pPrev->pNext = 0

		pIn->pPrev = pOut

		pOut->pNext = pIn

		pOut->pPrev = 0

		pFirst = pOut

	ElseIf pOut->pPrev = 0  AndAlso pIn->pNext = 0 Then

		pOut->pNext->pPrev = 0

		pFirst = pOut->pNext

		pIn->pNext = pOut

		pOut->pNext = 0

		pOut->pPrev = pIn

	elseIf pOut->pNext = 0 Then

		pOut->pPrev->pNext = 0

		pIn->pPrev->pNext = pOut

		pOut->pPrev = pIn->pPrev

		pOut->pNext = pIn

		pIn->pPrev = pOut

	elseIf pOut->pPrev = 0 Then

		pOut->pNext->pPrev = 0

		pFirst = pOut->pNext

		pIn->pNext->pPrev = pOut

		pOut->pNext = pIn->pNext

		pOut->pPrev = pIn

		pIn->pNext = pOut

	elseIf pIn->pNext = 0 Then

		pOut->pPrev->pNext = pOut->pNext

		pOut->pNext->pPrev = pOut->pPrev

		pIn->pNext = pOut

		pOut->pPrev = pIn

		pOut->pNext = 0

	elseIf pIn->pPrev = 0 Then

		pOut->pPrev->pNext = pOut->pNext

		pOut->pNext->pPrev = pOut->pPrev

		pOut->pNext = pIn

		pIn->pPrev = pOut

		pFirst = pOut
		
		pOut->pPrev = 0

	else

		pOut->pNext->pPrev = pOut->pPrev

		pOut->pPrev->pNext = pOut->pNext

		If iIndexFrom < iIndexIn Then

			pIn->pNext->pPrev = pOut

			pOut->pNext = pIn->pNext

			pIn->pNext = pOut

			pOut->pPrev = pIn

		Else

			pIn->pPrev->pNext = pOut

			pOut->pPrev = pIn->pPrev

			pOut->pNext = pIn

			pIn->pPrev = pOut

		EndIf

	EndIf

End Function
