' Set Style (color,font) for "window output information"
Sub set_visual_params_build_info_proc(iParam As Byte = 0)

   get_theme_color(iParam)

   IupSetAttribute(TGlobalVariables->buildbox, "BGCOLOR" , TGlobalVariables->szColorbtn(2))

   IupSetAttribute(TGlobalVariables->buildbox, "FGCOLOR" , TGlobalVariables->szColorbtn(10))

   Dim As ZString*100 szFont

   If iParam = 0 Then

      szFont = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winout")

   Else

      szFont = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"ftxtwinout"),"VALUE")

   EndIf

	If InStr(szFont, " Bold ") Then 
	   
	   szFont = replace_string_proc(szFont , " Bold " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Italic ") Then 
	   
	   szFont = replace_string_proc(szFont , " Italic " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Underline ") Then 
	   
	   szFont = replace_string_proc(szFont , " Underline " , " " )	   
	   
	EndIf
	
	If InStr(szFont, " Strikeout ") Then 
	   
	   szFont = replace_string_proc(szFont , " Strikeout " , " " )	   
	   
	EndIf	

   Dim As Integer iPosSpace = InStrRev(szFont , " ")

   TGlobalVariables->szFontWinOutSize = Mid(szFont , iPosSpace , (Len(szFont) - iPosSpace)+1)

   TGlobalVariables->szFontWinOut = RTrim(Mid(szFont , 1 , iPosSpace) , Any " ,")

   IupSetAttribute(TGlobalVariables->buildbox, "FONTFACE" , TGlobalVariables->szFontWinOut)

   IupSetAttribute(TGlobalVariables->buildbox, "FONTSIZE" , TGlobalVariables->szFontWinOutSize)

End Sub

' Create window output information: compilation, search
Function Create_build_info_BuildBox_proc() As IHandle Ptr

   Dim As IHandle Ptr pList = IupList(NULL)

   IupSetAttributes(pList, "EXPAND=YES")

   IupSetAttributes(pList, "MULTIPLE=YES")
   
   IupSetAttributes(pList, "MAXSIZE=x400")

   IupSetCallback(pList, "BUTTON_CB", Cast(Any Ptr,@buildbox_button_callback))

   Return pList

End Function

Function find_errorlines_proc(sTextError As String  , sFindErr As String ) As Integer

   If Len(sTextError) = 0 Then Return 0

   Dim As Long idTabs

   Dim As Long iTabsCompFile = Val(*IupGetAttribute(TGlobalVariables->tabs, "CURRENTCOMPILE"))

   If iTabsCompFile = 0 Then Return 0

   Dim As Long iFindPos = 1

   iFindPos = InStr(iFindPos , sTextError , sFindErr)

   If iFindPos Then

      Dim As Long iFindColon = InStr(iFindPos , sTextError , ":")

      If iFindColon Then

         If (iFindColon - iFindPos) < 20 Then

            Dim As Long iFindBegin = InStrRev( sTextError , "(" , iFindPos)

            Dim As String sPathFileError = Left(sTextError , iFindBegin-1)

            Dim As String sPathCurent = *IupGetAttribute(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext,"FILEPATH") & _
            *IupGetAttribute(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext,"FILENAME")
            
            sPathFileError = encode_path(sPathFileError , 0)
            
            If sPathFileError <> sPathCurent  AndAlso InStr(sPathFileError,"FBTEMP.bas") = 0 Then

               Dim As Integer iCountTabs = IupGetInt(TGlobalVariables->tabs, "COUNT")

               Dim As Byte iFlagFound

               For i As Long  = 1 To iCountTabs - 1

                  sPathCurent = *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext,"FILEPATH") & _
                  *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext,"FILENAME")

                  If sPathFileError = sPathCurent Then

                     idTabs = i

                     IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(i))

                     IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)

                     iFlagFound = 1

                     Exit For

                  EndIf

               Next
               
               If iFlagFound = 0 Then

                  open_file_proc(sPathFileError)

                  idTabs = iCountTabs

               EndIf

            Else

               IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(iTabsCompFile))

               IupSetFocus(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext)

               idTabs = iTabsCompFile

            EndIf

            Dim As Integer iIndexList = Val( Mid(sTextError , iFindBegin+1 , (iFindPos - iFindBegin)-1) )

            Dim As Integer iNumberLinesEditor = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")
            
            If iNumberLinesEditor < iIndexList Then Return 0

            Dim As Integer iPos , iPos2 , iLenLine

            iLenLine = Len(RTrim(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "LINE" & (iIndexList -1)), Any Chr(13) & Chr(10) ))

            IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iIndexList - 1, 0, Cast(Any Ptr,@iPos))

            iPos2 = iPos + iLenLine

            IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)
            
            IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPos, iPos2)

            IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLTOPOS", iPos)

            IupSetFocus(TGlobalVariables->buildbox)

            Return 1

         EndIf

      EndIf

   EndIf

End Function

Sub processing_click_mouse_buildbox_proc(ih As Ihandle Ptr, button As Integer , pressed As Integer, x As Integer , y As Integer , pszStatus As ZString Ptr)

   If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub

   Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
   
   Select Case button

      Case IUP_BUTTON1

         If pressed = 0 Then

            If TGlobalVariables->bFlagFindInfo = 1 Then

               Dim As ZString Ptr pszFind = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FOUNDSTRING")

               If *pszFind <> "" Then

                  Dim As Integer iPos = IupConvertXYToPos(ih , x ,y)

                  If iPos = CInt(-1) Then Exit Sub

                  Dim As ZString Ptr pszText = IupGetAttribute(ih, Str(iPos))

                  Dim As Integer iPosbeg , iPosend , ifl

                  ifl = InStr(*pszText,";")

                  iPosbeg = Val(Mid(*pszText,6,ifl-6))

                  iPosend = iPosbeg + Len(*pszFind)

                  IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPosbeg, iPosend)

                  IupSetFocus(TGlobalVariables->buildbox)

               EndIf

            Else

               Dim As Integer iCount , iPos

               iCount = Val(*IupGetAttribute(ih,"COUNT"))

               iPos = IupConvertXYToPos(ih , x ,y)
               
               Select Case iPos

                  Case CInt(-1) , CInt(1) , CInt(2) , CInt(iCount)

                     Exit Sub

               End Select

               Dim As String sTextError = *IupGetAttribute(ih, Str(iPos))

               If find_errorlines_proc(sTextError , ") error ") = 0 Then

                  find_errorlines_proc(sTextError , ") warning ")

               EndIf

            EndIf

         EndIf

      Case IUP_BUTTON3
         
         If pressed = 0 Then

            Dim As Integer iCount

            iCount = Val(*IupGetAttribute(ih,"COUNT"))
            
            If iCount Then
               
               menu_popup_buildbox_proc()
               
            EndIf
                       
         EndIf

   End Select

End Sub

' 0 - select items text , 1 - all items text
Sub copy_text_from_buildbox( bParam As Byte) 
   
   Dim As String sText
   
   Dim As String sEOL
   
   #Ifdef __FB_WIN32__
   
   sEOL = Chr(13) & Chr(10)
   
   #Else
   
   sEOL = Chr(10)
   
   #EndIf
   
   Dim As Ihandle Ptr bb = TGlobalVariables->buildbox
   
   Dim As Integer iCount = Val(*IupGetAttribute(bb,"COUNT")) 
   
   If bParam  = 0 Then 
      
      Dim As String sStatusSelect = *IupGetAttribute(bb,"VALUE")
      
      For i As Long = 1 To iCount
         
         If Mid(sStatusSelect , i , 1) = "+" Then
            
            sText &= (*IupGetAttribute(bb,Str(i)) & sEOL)
            
         EndIf
         
      Next
      
   Else
      
      For i As Long = 1 To iCount
            
            sText &= (*IupGetAttribute(bb,Str(i)) & sEOL)
         
      Next      
      
   EndIf
   
   If Len(sText) Then
      
      Dim As Ihandle Ptr clipboard = IupClipboard()
      
      IupSetAttribute(clipboard, "TEXT", sText)
      
      IupDestroy(clipboard)
      
   EndIf
   
End Sub

' processing popup menu buildbox show only errors
Sub popup_buildbox_only_errors () 
   
   Dim As Long iIndex = 3
   
   Static As ZString*12 szResult
   
   szResult = *IupGetAttribute(TGlobalVariables->buildbox,IupGetAttribute(TGlobalVariables->buildbox , "COUNT"))
   
   IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
   
	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))
	
	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")   
   
   For i As Long = 3 To 1000
      
      If pszDimErrors(i) Then
         
         If InStr(*(pszDimErrors(i)),") warning ") Then
            
         Else   
            
            IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex) , pszDimErrors(i))
            
            iIndex +=1
            
         EndIf        
         
      EndIf
      
   Next
   
   IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex), " ")
   
   IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex+1), szResult)
   
End Sub

' processing popup menu buildbox show only warnings
Sub popup_buildbox_only_warnings ()

   Dim As Long iIndex = 3
   
   Static As ZString*12 szResult
   
   szResult = *IupGetAttribute(TGlobalVariables->buildbox,IupGetAttribute(TGlobalVariables->buildbox , "COUNT"))
   
   IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
   
	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))
	
	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")   
   
   For i As Long = 3 To 1000
      
      If pszDimErrors(i) Then
         
         If InStr(*(pszDimErrors(i)),") warning ") Then
            
            IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex) , pszDimErrors(i))
            
            iIndex +=1
            
         EndIf        
         
      EndIf
      
   Next
   
   IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex), " ")
   
   IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex+1), szResult) 
   
End Sub

' processing popup menu buildbox show warnings and errors
Sub popup_buildbox_errors_and_warnings () 
   
   Dim As Long iIndex = 3
   
   Static As ZString*12 szResult
   
   szResult = *IupGetAttribute(TGlobalVariables->buildbox,IupGetAttribute(TGlobalVariables->buildbox , "COUNT"))
   
   IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")

	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))
	
	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")  
   
   For i As Long = 3 To 1000
      
      If pszDimErrors(i) Then
            
         IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex) , pszDimErrors(i))
         
         iIndex +=1
         
      EndIf
      
   Next  
   
   IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex), " ")
   
   IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex+1), szResult)    
   
End Sub
